//
//  KSTokenField.h
//  KSFormatters
//
//  Created by Ferhat Ayaz on 25.04.07.
//  Copyright 2007 KediSoft. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "KSToken.h"

extern NSString *KSTokenFieldWillChangeTokensNotification;
extern NSString *ksUserInfoTokens;

@interface KSTokenField : NSTokenField {
	NSMutableArray *_allowedTokenCodes;
	NSObject *_ksDelegate;
}
- (void)addAllowedTokenCode:(NSString*)aTokenCode;
- (void)setAllowedTokenCodes:(NSArray*)tokenCodes;
- (void)removeAllowedTokenCode:(NSString*)aTokenCode;

- (void)setToken:(KSToken*)aToken;
- (KSToken*)setTokenWithTitle:(NSString*)aTitle tokenCode:(NSString*)aTokenCode;

- (NSString*)joinTokensToString;

- (void)setKSDelegate:(NSObject*)aDelegate;
@end

@interface NSObject (KSTokenFieldDelegate)
- (BOOL)ksTokenField:(KSTokenField*)tokenField hasMenuForToken:(KSToken*)aToken;
- (NSMenu*)ksTokenField:(KSTokenField*)tokenField menuForToken:(KSToken*)aToken;
@end